#Copyright (c) 2015 3D Control Systems LTD

# Author: Vladimir Avdeev <another.vic@yandex.ru>

import os
import sys
import os.path
import subprocess

import config
import platforms

class TrayController:

    def __init__(self):
        self.tray_process = self.start()

    def start(self):
        tray_settings = config.get_settings().get('tray_icon')
        if tray_settings.get('enabled'):
            if platforms.PLATFORM == 'mac':
                module_name = 'mac_tray.py'
            elif platforms.PLATFORM == 'win':
                module_name = 'wx_tray.py'
            elif platforms.PLATFORM == 'linux':
                module_name = 'gtk_tray.py'
            else:
                module_name = None
            if module_name:
                module_path = os.path.join(os.path.dirname(os.path.abspath(__file__)), module_name)
                return subprocess.Popen([sys.executable, module_path], close_fds=True)

    def stop(self):
        if self.tray_process:
            try:
                self.tray_process.terminate()
            except:
                pass
